CastepDensityReader
Date: 2019-10-22

org.jmol.jvxl.readers

## Class CastepDensityReader

- java.lang.Object
- - org.jmol.jvxl.readers.SurfaceReader
  - - org.jmol.jvxl.readers.SurfaceFileReader
    - - org.jmol.jvxl.readers.VolumeFileReader
      - - org.jmol.jvxl.readers.PeriodicVolumeFileReader
        - - org.jmol.jvxl.readers.CastepDensityReader

- All Implemented Interfaces:
    VertexDataServer

      class CastepDensityReader
      extends PeriodicVolumeFileReader

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private int` | `nFilePoints`
    `private int` | `nSkip`

    - ### Fields inherited from class org.jmol.jvxl.readers.VolumeFileReader

      `ac, boundingBox, canDownsample, downsampleFactor, downsampleRemainders, endOfData, isAngstroms, nData, negativeAtomCount, nSkipX, nSkipY, nSkipZ, nSurfaces, readerClosed`

    - ### Fields inherited from class org.jmol.jvxl.readers.SurfaceFileReader

      `binarydoc, br, line, next, out`

    - ### Fields inherited from class org.jmol.jvxl.readers.SurfaceReader

      `allowSigma, ANGSTROMS_PER_BOHR, anisotropy, center, cJvxlEdgeNaN, colorFractionBase, colorFractionRange, contourVertexCount, dataMax, dataMean, dataMin, defaultCutoff, defaultMappedDataMax, defaultMappedDataMin, eccentricityMatrix, eccentricityMatrixInverse, eccentricityRatio, eccentricityScale, edgeFractionBase, edgeFractionRange, fractionData, hasColorData, haveSurfaceAtoms, isAnisotropic, isEccentric, isJvxl, isPeriodic, isProgressive, isQuiet, isXLowToHigh, jvxlColorDataRead, jvxlCutoff, jvxlData, jvxlDataIs2dContour, jvxlDataIsColorDensity, jvxlDataIsColorMapped, jvxlDataIsPrecisionColor, jvxlEdgeDataRead, jvxlFileHeaderBuffer, jvxlNSurfaceInts, jvxlVoxelBitSet, marchingCubes, marchingSquares, meshData, meshDataServer, minMax, nBytes, nDataPoints, nPointsX, nPointsY, nPointsZ, params, ptTemp, qpc, sg, vertexDataOnly, volumeData, volumetricOrigin, volumetricVectors, voxelCounts, voxelData, xyzMax, xyzMin, yzCount, yzPlanes`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CastepDensityReader()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `getPeriodicVoxels()`
    `protected void` | `gotoData(int n, int nPoints)`
    `(package private) void` | `init2(SurfaceGenerator sg, java.io.BufferedReader br)`
    `protected void` | `readParameters()`
    `private void` | `skipPoints(int n)`

    - ### Methods inherited from class org.jmol.jvxl.readers.PeriodicVolumeFileReader

      `readSurfaceData`

    - ### Methods inherited from class org.jmol.jvxl.readers.VolumeFileReader

      `checkAtomLine, closeReader, getNextVoxelValue, getPlane, getPlaneNCI, getSPFv, getSurfacePointAndFraction, getValue, getVoxelBitSet, init2VFR, initializeSurfaceData, nextVoxel, readSurfaceDataVFR, readVolumeData, readVolumeDataVFR, readVolumeParameters, readVoxelVector, recordData, skipComments, skipData, skipDataVFR, swapXZ`

    - ### Methods inherited from class org.jmol.jvxl.readers.SurfaceFileReader

      `closeReaderSFR, discardTempData, getQuotedStringNext, getTokens, init, init2SFR, newBinaryDocument, parseFloat, parseFloatArray, parseFloatArrayStr, parseFloatRange, parseFloatStr, parseInt, parseIntNext, parseIntStr, rd, setOutputChannel, setStream, skipTo`

    - ### Methods inherited from class org.jmol.jvxl.readers.SurfaceReader

      `addTriangleCheck, addVC, addVertexCopy, applyColorScale, colorIsosurface, createIsosurface, discardTempDataSR, excludeMaximumSet, excludeMinimumSet, finalizeMapping, getColorPhaseIndex, getMinMaxMappedValues, getPlaneSR, getSPF, getSurfaceAtomIndex, getSurfacePointIndexAndFraction, getValue2, getValueAtPoint, gotoAndReadVoxelData, initializeMapping, initializeVolumetricData, initPlanes, initSR, jvxlUpdateInfo, newVoxelDataCube, postProcessVertices, readAndSetVolumeParameters, readColorData, resetIsosurface, selectPocket, setBBox, setVectorAnisotropy, setVertexAnisotropy, setVolumeDataV, setVolumetricAnisotropy, setVolumetricOriginAnisotropy, slabIsosurface, updateSurfaceData, updateTriangles`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### nFilePoints

          private int nFilePoints

    - #### nSkip

          private int nSkip

  - ### Constructor Detail

    - #### CastepDensityReader

          CastepDensityReader()

  - ### Method Detail

    - #### init2

          void init2(SurfaceGenerator sg,
                     java.io.BufferedReader br)

      Overrides:
        `init2` in class `VolumeFileReader`

    - #### gotoData

          protected void gotoData(int n,
                                  int nPoints)
                           throws java.lang.Exception

      Overrides:
        `gotoData` in class `VolumeFileReader`
      Throws:
        `java.lang.Exception`

    - #### readParameters

          protected void readParameters()
                                 throws java.lang.Exception

      Specified by:
        `readParameters` in class `VolumeFileReader`
      Throws:
        `java.lang.Exception`

    - #### getPeriodicVoxels

          protected void getPeriodicVoxels()
                                    throws java.lang.Exception

      Specified by:
        `getPeriodicVoxels` in class `PeriodicVolumeFileReader`
      Throws:
        `java.lang.Exception`

    - #### skipPoints

          private void skipPoints(int n)